---
- name: prepare host to build LFS
  hosts: host
  become: yes
  tasks:
    - name: retrive raw command path
      command: which {{ item }}
      register: raw_command_paths
      loop:
        - sh
        - bash
        - yacc
        - bison
        - awk
        - gawk
      changed_when: false

    - name: transform raw paths
      set_fact:
        command_paths: "{{ command_paths | default({}) | combine({ item.item: item.stdout }) }}"
      loop: "{{ raw_command_paths.results }}"

    - name: setup alternative
      community.general.alternatives:
        name: sh
        link: /usr/bin/sh
        path: /bin/bash
      loop:
        - name: sh
          src: "{{ command_paths['bash'] }}"
          dest: "{{ command_paths['sh'] }}"
        - name: yacc
          src: "{{ command_paths['bison'] }}"
          dest: "{{ command_paths['yacc'] }}"
        - name: awk
          src: "{{ command_paths['gawk'] }}"
          dest: "{{ command_paths['awk'] }}"

    - name: add lfs group
      group:
        name: "{{ lfs_user.group }}"
        state: present

    - name: add lfs user
      user:
        name: "{{ lfs_user.name }}"
        group: "{{ lfs_user.group }}"
        shell: "{{ lfs_user.shell }}"
        state: present
      register: user_info

    - name: create config file for user lfs
      template:
        src: "{{ item.src }}"
        dest: "{{ item.dest }}"
        owner: "{{ lfs_user.name }}"
        group: "{{ lfs_user.group }}"
      loop:
        - src: templates/bash_profile.sh.j2
          dest: "{{ user_info.home }}/.bash_profile"
        - src: templates/bashrc.sh.j2
          dest: "{{ user_info.home }}/.bashrc"

    - name: create dir layout
      file:
        state: directory
        path: "{{ lfs_main_directory }}/{{ item }}"
        owner: "{{ lfs_user.name }}"
      loop:
        - bin
        - etc
        - lib
        - sbin
        - usr
        - var
        - tools

    - name: change owner on source folder
      file:
        state: directory
        path: "{{ lfs_sources_dir }}"
        owner: "{{ lfs_user.name }}"
        recurse: true
        force: true

    - name: create lib64 folder
      file:
        state: directory
        path: "{{ lfs_main_directory }}/lib64"
        owner: "{{ lfs_user.name }}"
      when: ansible_facts['architecture'] == 'x86_64'

    # TODO rework
    - name: config ld
      lineinfile:
        path: /etc/ld.so.conf.d/libc.conf
        line: /usr/lib/x86_64-linux-gnu
